#ifdef COMMENTOUT
Bill

Here is my version of the planets prog.
I also have several other astro type progs.
Stop by sometime and I will show you what I have.
Am interested in sharing/exchanging stuff like this.
Do you have a satellite orbits prog?

	Dick

+++++
Bumper sticker on farmers pickup.   "Promote Pork --- Run over a chicken"
F. R. "Dick" George	AT&T Bell Laboratories 	Indian Hill 6B-335
Naperville-Wheaton Road	Naperville, IL  60566	312/979-4221
...!ihnp4!ihwld!w9skd		
+++++

---------------------- cut here --------------------------
#endif
/*	planet.c

	Modifications by ihnp4!ihwld!w9skd  (F. R. George)
	1.00 860103 use initopts, show month name, colon in HH:MM
	1.01 860124 fix neptune calc

	Modification by W. J. Krauss
	1.02 900107 port to AT&T 6300+: had to change "int" to "long",
		    everywhere and fix a couple printfs and call for
		    getting time.  Later, added altitude and azimuth,
		    and more command line options.

	Modification by L. Mammel
	1.03 021114 Corrected Greenwich Sideral Time calculation,
		    which was off by six minutes.

	Modification by W. J. Krauss
	1.04 070412 Fixed help message: "month/day/year"
	1.05 070701 Printed seconds in R.A and hour angle
	1.06 080614 Added width of objects in arcseconds
	1.07 090424 Added elongation and percent illuminated
	1.08 090810 Fixed elongation
	1.09 100410 Fixed diameter of Mercury (previous half of correct value)
	1.10 121111 Change input parameter format, etc.
*/

#define	VERNUM	"1.10"

/*
 *  From netnews Planets2.c
 *           A program to determine the position of
 *	     the Sun., Mer., Ven., Mars, Jup, Sat & Ura

 *  reference Jean Meesus's book, " Astronomical Formulae for 
 *  Calculators 
 *			program by     
 *
 *			F.T. Mendenhall  
 *			ihnp4!inuxe!fred
 *
 *		Copyright 1985 by F.T. Mendenhall
 *		all rights reserved
 *
 * (This copyright prevents you from selling the program - the
 *  author grants anyone the right to copy and install the program
 *  on any machine it will run on)
*/

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
long time();

/* define bool symbols */
typedef enum {
	false = 0,
	true = 1
} bool;

/* March 20, 1986, 16:03 CST was a vernal equinox; use as a reference */
#define TVEQ	(22./24. + 3./24./60.)	/* fraction of a day */
#define JDVEQ	2446510.418750		/* Julian date of it */

/* mean solar days/siderial year (actually ephemeris days; close enough) */
#define MSDPSY	365.256366

/* sideral days per mean solar day */
#define SIDPSOL	( (MSDPSY + 1) / MSDPSY )

#define PI	3.141592653589793

/* find number of elements in an array */
#define NUMELEM(array)  (sizeof (array) / sizeof (array[0]))

double kepler();
double truean();
double longi();
double lati();
double poly();
double aint();
double range();
long cls();
long trans();
long speak();
double pfmod();
void praltaz();
double rad;
void get_coords();
int hms_str2float(char *str, float *ans_ptr);
int dms_str2float(char *str, float *ans_ptr);
void float_to_3_longs(float f, long *a_ptr, long *b_ptr, long *c_ptr);
void error(char *format, ...);

long th;
long tm;
long ts;
long mo;			/* month num Jan = 1	*/
long day;			/* day of month		*/
long yr;			/* four digits		*/
long tz=6;			/* Default time zone	*/
char *tzs = "(CST)";		/* Default time zone string */
char *dtzs = "(CDT)";		/* Default daylight savings time string */
double greensid;		/* Greenwich sideral time in radians */
long latd, latm, lats;		/* north latitude degrees, minutes, seconds */
long lond, lonm, lons;		/* west longitude degrees, minutes, seconds */
double latitude;		/* north latitude radians */
double longitude;		/* west longitude radians */
double Sun_x, Sun_y, Sun_z;	/* sun's coordinates */
double Sun_d;			/* distance to the sun */
char	*mtab[] = {
	"dummy", "January", "February", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December",
	};
char *Prog;



main(argc, argv)
int	argc;
char	*argv[];
{
	long mm,dd,yy, aa1,bb1;
	double otime;	/* hundredths of an hour since start of Julian day */
	double jd,year,month,oday,T0;

	double l,a,e,i,w1,w2,M,M0,M1,M2,M4,M5,M6,M7,M8;
	double a0,a1,a2,a3,RA,DEC;
	double ECC,nu,r,u,ll,b,lonpert,radpert;
	double esun,Lsun,Cen,Stheta,Snu,Sr;
	double N,D,epli,thapp,omeg;
	double nu2,P,Q,S,V,W,ze,l1pert,epert,w1pert,apert;
	double psi,H,G,eta,oth;
	double sun_ra_rad, sun_dec_rad;	/* sun's R.A. and dec in radians */
	
	int sign;
	time_t sec_1970;
	long h, m;
	struct tm *pt;

	Prog = argv[0];
	rad = PI/180.0;

	/* get system date & time, default if user doesn't supply them */

	sec_1970 = time((time_t *)0);  
	pt = localtime(&sec_1970);  

	th = pt->tm_hour;
	tm = pt->tm_min;
	ts = pt->tm_sec;
	yr = pt->tm_year + 1900;	/* unix uses last two digits	*/
	mo = pt->tm_mon + 1;		/* unix uses Jan = 0	*/
	day = pt->tm_mday;

	/* convert tz to daylight savings time */
	if (pt->tm_isdst) {
		tz--;
		tzs = dtzs;	
	}

	/* set default location to be Elgin, Illinois */
	latd = 42, latm =  0; lats = 0;
	lond = 88, lonm = 16; lons = 0;

	/* get user's arguments to override defaults */
	initopts(argc,argv);

	latitude  = ((double)latd + (double)latm/60 + (double)lats/3600) * rad;
	longitude = ((double)lond + (double)lonm/60 + (double)lons/3600) * rad;

	printf("planet.c	Version %s \n", VERNUM);

	/* for now just copy my time vars into his */
	mm = mo;
	dd = day;
	yy = yr;
	otime = ((double)th + (double)tm/60.0 + (double)ts/3600.0) * 100.0;
	/* tz is ok */
	/* show the month name instead of just the numbers */
	if ( (mm < 1) || ( mm > 12) ) {
		printf("Invalid month (%ld) \n", mm);
		usage();
		exit(1);
	}

	printf(" Date:  %s %ld, %ld", mtab[(int)mm], dd, yy);
	printf("   Time: %02ld:%02ld:%02ld %s", th, tm, ts, tzs);

/*   */
/*  Calculate the Julian date for the time of observation */
	
	oday = ((double)dd + (otime +(double)tz*100.0)/2400.0);
	if (mm > 2)
	{
		year = yy;
		month = mm;
	}
	else
	{
		year = yy - 1;
		month = mm + 12;
	}
	aa1 = (long) (year/100);
	bb1 = 2 - aa1 + (long)(aa1/4);
	jd = aint(365.25*year) + aint(30.6001*(month + 1));
	jd = jd  + oday + 1720994.5;
	if (year < 0)
	{
		cls();
		printf("Negative year not allowed- abort");
		exit(1);
	}
	if((year + month/100) > 1582.10)
	{
		jd = jd + bb1;
	}
	printf("   Julian date: %f\n", jd);

	printf(" Place: %ldo %ld' %ld\" %s latitude, ",
		abs(latd), abs(latm), abs(lats), latd >= 0 ? "north" : "south");
	printf("%ldo %ld' %ld\" %s longitude\n",
		abs(lond), abs(lonm), abs(lons), lond >= 0 ? "west" : "east");
	
/*  calculate time T0 from 1900 January 0.5 ET */

	T0 = (jd - 2415020.0)/36525.0;

/* calculate the Greenwich siderial time */
	/*
	 * Find the Greenwich sideral time, using "JD2000" as a reference.  See
	 * http://www.pietro.org/Astro_Util_StaticDemo/FDetailSideralConv.html
	 * or http://www.astro.washington.edu/deutsch-bin/getpro/
	 * library32.html?C%2LST for info on this.  Convert to radians.
	 */
	greensid = 280.46061837 + (jd - 2451545.0) * 360.98564736629;
	greensid /= 360.0;
	greensid = pfmod(greensid, 1.);
	greensid *= 2 * PI;

/* Calculate orbital elements for Mercury */
	a0=178.179078;
	a1=149474.07078;
	a2=0.0003011;
	a3=0.0;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 0.3870986;
	a0 = 0.20561421;
	a1 = 0.00002046;
	a2 = -0.000000030;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 7.002881;
	a1 = 0.0018608;
	a2 = -0.0000183;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 28.753753;
	a1 = 0.3702806;
	a2 = 0.0001208;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 47.145944;
	a1 = 1.1852083;
	a2= 0.0001739;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
	M1 = 102.27938 + 149472.51529*T0 + 0.000007*T0*T0;
	M1 = range(M1);
	
/* solving Kepler find the eccentric anomaly ECC    */

	ECC =kepler(e,M1);
	nu = truean(e,ECC);
	r = a*(1.0 - e * cos(ECC*PI/180.0));
	u = l + nu - M1 - w2;
	ll = longi(w2,i,u);
	b = lati(u,i);
	
/* Now make corrections due to perturbations */
	M2 = 212.60322 + 58517.80387*T0 +0.001286*T0*T0;
	M2 = range(M2);
	M4 = 319.51913 + 19139.85475*T0 + 0.000181*T0*T0;
	M4 = range(M4);
	M5 = 225.32833 + 3034.69202*T0 - 0.000722*T0*T0;
	M5 = range(M5);
	M6 = 175.46622 +1221.55147*T0 - 0.000502*T0*T0;
	M6 = range(M6);
	lonpert = 0.00204*cos((5*M2-2*M1+12.220)*rad)
		 +0.00103*cos((2*M2-M1-160.692)*rad)
		 +0.00091*cos((2*M5-M1-37.003)*rad)
		 +0.00078*cos((5*M2-3*M1+10.137)*rad);
		
	radpert = 0.000007525*cos((2*M5-M1+53.013)*rad)
		 +0.000006802*cos((5*M2-3*M1-259.918)*rad)
		 +0.000005457*cos((2*M2-2*M1-71.188)*rad)
		 +0.000003569*cos((5*M2-M1-77.75)*rad);
		
		r = r + radpert;
		ll = ll + lonpert;
		
/* Now find the Longi and radius vector of the sun */
		
		M= 358.47583 + 35999.04975*T0 - 0.000150*T0*T0
		   -0.0000033*T0*T0*T0;
		M = range(M);
		esun = 0.01675104 - 0.0000418*T0 -0.000000126*T0*T0;
		Lsun = 279.69668 + 36000.76892*T0 + 0.0003025*T0*T0;
		Lsun = range(Lsun);
		Cen= (1.919460-0.004789*T0-0.000014*T0*T0)*sin(M*rad)
		     +(0.020094 - 0.000100*T0)*sin(2*M*rad)
		     +0.000293*sin(3*M*rad);
		
		Stheta= Lsun + Cen;
		Stheta = range(Stheta);
		Snu = M + Cen;
		Sr = 1.0000002*(1.0 - esun*esun)/(1.0 + esun*cos(Snu*rad));

		omeg= 259.18 - 1934.142*T0;
		thapp = Stheta - 0.00569 - 0.00479* sin(omeg*rad);
		epli = 23.452294 - 0.0130125*T0
		       -0.00000164*T0*T0 + 0.000000503*T0*T0*T0
			+0.00256*cos(omeg*rad);
		printf("\nOBJECT   R.A.       DEC      DIST  WIDTH    ELONG  ILLUM    HOUR ANG   ALTITUDE AZIMUTH");
		printf("\nSun  ");
		N = cos(epli*rad)*sin(thapp*rad);
		D = cos(thapp*rad);
		RA = atan2(N,D)/rad;
		DEC = asin(sin(epli*rad)*sin(thapp*rad))/rad;

		/* find and store Sun's coordinates */
		get_coords(Sr, RA, DEC, &Sun_x, &Sun_y, &Sun_z);
		Sun_d = Sr;	/* save this too */
		speak(true, RA,DEC,Sr, 1391000.);

/* tansformation of coordinates on Mercury and ouput */
		printf("\nMer  ");
		trans(r,b,ll,Stheta,Sr,epli, 4879.4);
		
/* Now start on Venus */
	a0 = 342.767053;
	a1 = 58519.21191;
	a2 = 0.0003097;
	a3 = 0.0;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 0.7233316;
	a0 = 0.00682069;
	a1 = -0.00004774;
	a2 = 0.000000091;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 3.393631;
	a1 = 0.0010058;
	a2 = -0.0000010;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 54.384186;
	a1 = 0.5081861;
	a2 = -0.0013864;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 75.779647;
	a1 = 0.8998500;
	a2 = 0.0004100;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
/* Venus has a long period pert that needs to be added before Kelper */
	lonpert = 0.00077 *sin((237.24 + 150.27*T0)*rad);
	l = l + lonpert;
	M0 = M2 + lonpert;
	ECC = kepler(e,M0);
	nu = truean(e,ECC);
	r = a*(1.0 - e * cos(ECC*rad));
	u = l + nu - M0- w2;
	ll = longi(w2,i,u);
	b = lati(u,i);
	
/* now Venus perturbations */
	
	lonpert = 0.00313*cos((2*M-2*M2 -148.225)*rad)
		 +0.00198*cos((3*M-3*M2 +2.565)*rad)
		 +0.00136*cos((M-M2-119.107)*rad)
		 +0.00096*cos((3*M-2*M2-135.912)*rad)
		 +0.00082*cos((M5-M2-208.087)*rad);
	ll = ll + lonpert;
	
	radpert = 0.000022501 * cos((2*M-2*M2-58.208)*rad)
		 +0.000019045 * cos((3*M-3*M2+92.577)*rad)
		 +0.000006887 * cos((M5-M2-118.090)*rad)
		 +0.000005172 * cos((M-M2-29.110)*rad)
		 +0.000003620 * cos((5*M-4*M2-104.208)*rad)
		 +0.000003283 * cos((4*M-4*M2+63.513)*rad)
		 +0.000003074 * cos((2*M5-2*M2-55.167)*rad);
	r = r + radpert;
	printf("\nVen  ");
	trans(r,b,ll,Stheta,Sr,epli, 12105.);
	
/* Now  start the planet Mars */
	a0 = 293.737334;
	a1 = 19141.69551;
	a2 = 0.0003107;
	a3 = 0.0;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 1.5236883;
	a0 = 0.09331290;
	a1 = 0.000092064;
	a2 = -0.000000077;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 1.850333;
	a1 = -0.0006750;
	a2 = 0.0000126;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 285.431761;
	a1 = 1.0697667;
	a2 = 0.0001313;
	a3 = 0.00000414;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 48.786442;
	a1 = 0.7709917;
	a2 = -0.0000014;
	a3 = -0.00000533;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);

/* Mars has a long period perturbation */
	lonpert = -0.01133*sin((3*M5-8*M4 +4*M)*rad)
		  -0.00933*cos((3*M5-8*M4 +4*M)*rad);
	l = l + lonpert;
	M0 = M4 + lonpert;
	ECC = kepler(e,M0);
	nu = truean(e,ECC);
	r = a*(1.0 - e * cos(ECC*rad));
	u = l + nu - M0- w2;
	ll = longi(w2,i,u);
	b = lati(u,i);
	
/* Now Mars Perturbations */	
	lonpert = 0.00705*cos((M5-M4-48.958)*rad)
		 +0.00607*cos((2*M5-M4-188.350)*rad)
		 +0.00445*cos((2*M5-2*M4-191.897)*rad)
		 +0.00388*cos((M-2*M4+20.495)*rad)
		 +0.00238*cos((M-M4+35.097)*rad)
		 +0.00204*cos((2*M-3*M4+158.638)*rad)
		 +0.00177*cos((3*M4-M2-57.602)*rad)
		 +0.00136*cos((2*M-4*M4+154.093)*rad)
		 +0.00104*cos((M5+17.618)*rad);
	ll = ll + lonpert;
	
	radpert = 0.000053227*cos((M5-M4+41.1306)*rad)
		 +0.000050989*cos((2*M5-2*M4-101.9847)*rad)  
		 +0.000038278*cos((2*M5-M4-98.3292)*rad)
		 +0.000015996*cos((M-M4-55.555)*rad)
		 +0.000014764*cos((2*M-3*M4+68.622)*rad)
		 +0.000008966*cos((M5-2*M4+43.615)*rad)
		 +0.000007914*cos((3*M5-2*M4-139.737)*rad)
		 +0.000007004*cos((2*M5-3*M4-102.888)*rad)
		 +0.000006620*cos((M-2*M4+113.202)*rad)
		 +0.000004930*cos((3*M5-3*M4-76.243)*rad)
		 +0.000004693*cos((3*M-5*M4+190.603)*rad)
		 +0.000004571*cos((2*M-4*M4+244.702)*rad)
		 +0.000004409*cos((3*M5-M4-115.828)*rad);
	r = r + radpert;
	printf("\nMar  ");
	trans(r,b,ll,Stheta,Sr,epli, 6786.2452);
	
/* Now start Jupiter */
	a0 = 238.049257;
	a1 = 3036.301986;
	a2 = 0.0003347;
	a3 = -0.00000165;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 5.202561;
	a0 = 0.04833475;
	a1 = 0.000164180;
	a2 = -0.0000004676;
	a3 = -0.0000000017;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 1.308736;
	a1 = -0.0056961;
	a2 = 0.0000039;
	a3 = 0.0;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 273.277558;
	a1 = 0.5994317;
	a2 = 0.00070405;
	a3 = 0.00000508;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 99.443414;
	a1 = 1.0105300;
	a2 = 0.00035222;
	a3 = -0.00000851;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
/*
	Now start perturbation calclations */
	
	nu2 = T0/5.0 +0.1;
	P = 237.47555 +3034.9061*T0;
	Q = 265.91650 + 1222.1139*T0;
	S = 243.51721 + 428.4677*T0;
	V = 5.0*Q -2.0*P;
	W = 2.0*P - 6.0*Q +3.0*S;
	ze = Q - P;
	psi = S - Q;
	
	P = range(P)*rad;
	Q = range(Q)*rad;
	S = range(S)*rad;
	V = range(V)*rad;
	W = range(W)*rad;
	ze = range(ze)*rad;
	psi = range(psi)*rad;
	
l1pert = (0.331364 - 0.010281*nu2 - 0.004692*nu2*nu2)*sin(V)
	+(0.003228 - 0.064436*nu2 + 0.002075*nu2*nu2)*cos(V)
	-(0.003083 + 0.000275*nu2 - 0.000489*nu2*nu2)*sin(2*V)
	+0.002472*sin(W)
	+0.013619*sin(ze)
	+0.018472*sin(2*ze)
	+0.006717*sin(3*ze)
	+0.002775*sin(4*ze)
	+(0.007275 - 0.001253*nu2)*sin(ze)*sin(Q)
	+0.006417*sin(2*ze)*sin(Q)
	+0.002439*sin(3*ze)*sin(Q);
	
l1pert = l1pert	-(0.033839 + 0.001125*nu2)*cos(ze)*sin(Q)
	-0.003767*cos(2*ze)*sin(Q)
	-(0.035681 + 0.001208*nu2)*sin(ze)*cos(Q)
	-0.004261*sin(2*ze)*cos(Q)
	+0.002178*cos(Q)
	+(-0.006333 + 0.001161*nu2)*cos(ze)*cos(Q)
	-0.006675*cos(2*ze)*cos(Q)
	-0.002664*cos(3*ze)*cos(Q)
	-0.002572*sin(ze)*sin(2*Q)
	-0.003567*sin(2*ze)*sin(2*Q)
	+0.002094*cos(ze)*cos(2*Q)
	+0.003342*cos(2*ze)*cos(2*Q);
	
epert =  (.0003606 + .0000130*nu2 - .0000043*nu2*nu2)*sin(V)
	+(.0001289 - .0000580*nu2)*cos(V)
	-.0006764*sin(ze)*sin(Q)
	-.0001110*sin(2*ze)*sin(Q)
	-.0000224*sin(3*ze)*sin(Q)
	-.0000204*sin(Q)
	+(.0001284 + .0000116*nu2)*cos(ze)*sin(Q)
	+.0000188*cos(2*ze)*sin(Q)
	+(.0001460 + .0000130*nu2)*sin(ze)*cos(Q)
	+.0000224*sin(2*ze)*cos(Q)
	-.0000817*cos(Q);
	
epert = epert	+.0006074*cos(ze)*cos(Q)
	+.0000992*cos(2*ze)*cos(Q)
	+.0000508*cos(3*ze)*cos(Q)
	+.0000230*cos(4*ze)*cos(Q)
	+.0000108*cos(5*ze)*cos(Q)
	-(.0000956 + .0000073*nu2)*sin(ze)*sin(2*Q)
	+.0000448*sin(2*ze)*sin(2*Q)
	+.0000137*sin(3*ze)*sin(2*Q)
	+(-.0000997 + .0000108*nu2)*cos(ze)*sin(2*Q)
	+.0000480*cos(2*ze)*sin(2*Q);

epert = epert	+.0000148*cos(3*ze)*sin(2*Q)
	+(-.0000956 +.0000099*nu2)*sin(ze)*cos(2*Q)
	+.0000490*sin(2*ze)*cos(2*Q)
	+.0000158*sin(3*ze)*cos(2*Q)
	+.0000179*cos(2*Q)
	+(.0001024 + .0000075*nu2)*cos(ze)*cos(2*Q)
	-.0000437*cos(2*ze)*cos(2*Q)
	-.0000132*cos(3*ze)*cos(2*Q);
	
w1pert = (0.007192 - 0.003147*nu2)*sin(V)
	+(-0.020428 - 0.000675*nu2 + 0.000197*nu2*nu2)*cos(V)
	+(0.007269 + 0.000672*nu2)*sin(ze)*sin(Q)
	-0.004344*sin(Q)
	+0.034036*cos(ze)*sin(Q)
	+0.005614*cos(2*ze)*sin(Q)
	+0.002964*cos(3*ze)*sin(Q)
	+0.037761*sin(ze)*cos(Q);
	
w1pert = w1pert
	+0.006158*sin(2*ze)*cos(Q)
	-0.006603*cos(ze)*cos(Q)
	-0.005356*sin(ze)*sin(2*Q)
	+0.002722*sin(2*ze)*sin(2*Q)
	+0.004483*cos(ze)*sin(2*Q)
	-0.002642*cos(2*ze)*sin(2*Q)
	+0.004403*sin(ze)*cos(2*Q)
	-0.002536*sin(2*ze)*cos(2*Q)
	+0.005547*cos(ze)*cos(2*Q)
	-0.002689*cos(2*ze)*cos(2*Q);
	
lonpert = l1pert -(w1pert/e);
l = l + l1pert;
M0 = M5 + lonpert;
e = e + epert;
w1 = w1 + w1pert;

apert =  -.000263*cos(V)
	+.000205*cos(ze)
	+.000693*cos(2*ze)
	+.000312*cos(3*ze)
	+.000147*cos(4*ze)
	+.000299*sin(ze)*sin(Q)
	+.000181*cos(2*ze)*sin(Q)
	+.000204*sin(2*ze)*cos(Q)
	+.000111*sin(3*ze)*cos(Q)
	-.000337*cos(ze)*cos(Q)
	-.000111*cos(2*ze)*cos(Q);
	
a = a + apert;
ECC = kepler(e,M0);
nu = truean(e,ECC);
r = a*(1.0 - e * cos(ECC*rad));
u = l + nu - M0 - w2;
ll = longi(w2,i,u);
b = lati(u,i);

printf("\nJup  ");
trans(r,b,ll,Stheta,Sr,epli, 142983.);

/* Now start Saturn */

	a0 = 266.564377;
	a1 = 1223.509884;
	a2 = 0.0003245;
	a3 = -0.0000058;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 9.554747;
	a0 = 0.05589232;
	a1 = -0.00034550;
	a2 = -0.000000728;
	a3 = 0.00000000074;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 2.492519;
	a1 = -0.0039189;
	a2 = -0.00001549;
	a3 = 0.00000004;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 338.307800;
	a1 = 1.0852207;
	a2 = 0.00097854;
	a3 = 0.00000992;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 112.790414;
	a1 = 0.8731951;
	a2 = -0.00015218;
	a3 = -0.00000531;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
	
/* Now Saturn's perturbations */
	
l1pert = (-0.814181 + 0.018150*nu2 + 0.016714*nu2*nu2)*sin(V)
	 +(-0.010497 + 0.160906*nu2 - 0.004100*nu2*nu2)*cos(V)
	 +0.007581*sin(2*V)
	 -0.007986*sin(W)
	 -0.148811*sin(ze)
	 -0.040786*sin(2*ze)
	 -0.015208*sin(3*ze)
	 -0.006339*sin(4*ze)
	 -0.006244*sin(Q);
l1pert = l1pert 
	+(0.008931 + 0.002728*nu2)*sin(ze)*sin(Q)
	-0.016500*sin(2*ze)*sin(Q)
	-0.005775*sin(3*ze)*sin(Q)
	+(0.081344 + 0.003206*nu2)*cos(ze)*sin(Q)
	+0.015019*cos(2*ze)*sin(Q)
	+(0.085581 + 0.002494*nu2)*sin(ze)*cos(Q)
	+(0.025328 - 0.003117*nu2)*cos(ze)*cos(Q);
l1pert = l1pert 
	+0.014394*cos(2*ze)*cos(Q)
	+0.006319*cos(3*ze)*cos(Q)
	+0.006369*sin(ze)*sin(2*Q)
	+0.009156*sin(2*ze)*sin(2*Q)
	+0.007525*sin(3*psi)*sin(2*Q)
	-0.005236*cos(ze)*cos(2*Q)
	-0.007736*cos(2*ze)*cos(2*Q)
	-0.007528*cos(3*psi)*cos(2*Q);
	
epert = (-.0007927 + .0002548*nu2 +.0000091*nu2*nu2)*sin(V)
	+(.0013381 + .0001226*nu2 -.0000253*nu2*nu2)*cos(V)
	+(.0000248 - .0000121*nu2)*sin(2*V)
	-(.0000305 + .0000091*nu2)*cos(2*V)
	+.0000412*sin(2*ze)
	+.0012415*sin(Q)
	+(.0000390 -.0000617*nu2)*sin(ze)*sin(Q)
	+(.0000165 - .0000204*nu2)*sin(2*ze)*sin(Q)
	+.0026599*cos(ze)*sin(Q)
	-.0004687*cos(2*ze)*sin(Q);
epert = epert
	-.0001870*cos(3*ze)*sin(Q)
	-.0000821*cos(4*ze)*sin(Q)
	-.0000377*cos(5*ze)*sin(Q)
	+.0000497*cos(2*psi)*sin(Q)
	+(.0000163 - .0000611*nu2)*cos(Q)
	-.0012696*sin(ze)*cos(Q)
	-.0004200*sin(2*ze)*cos(Q)
	-.0001503*sin(3*ze)*cos(Q)
	-.0000619*sin(4*ze)*cos(Q)
	-.0000268*sin(5*ze)*cos(Q);
epert = epert
	-(.0000282 + .0001306*nu2)*cos(ze)*cos(Q)
	+(-.0000086 + .0000230*nu2)*cos(2*ze)*cos(Q)
	+.0000461*sin(2*psi)*cos(Q)
	-.0000350*sin(2*Q)
	+(.0002211 - .0000286*nu2)*sin(ze)*sin(2*Q)
	-.0002208*sin(2*ze)*sin(2*Q)
	-.0000568*sin(3*ze)*sin(2*Q)
	-.0000346*sin(4*ze)*sin(2*Q)
	-(.0002780 + .0000222*nu2)*cos(ze)*sin(2*Q)
	+(.0002022 + .0000263*nu2)*cos(2*ze)*sin(2*Q);
epert = epert
	+.0000248*cos(3*ze)*sin(2*Q)
	+.0000242*sin(3*psi)*sin(2*Q)
	+.0000467*cos(3*psi)*sin(2*Q)
	-.0000490*cos(2*Q)
	-(.0002842 + .0000279*nu2)*sin(ze)*cos(2*Q)
	+(.0000128 + .0000226*nu2)*sin(2*ze)*cos(2*Q)
	+.0000224*sin(3*ze)*cos(2*Q)
	+(-.0001594 + .0000282*nu2)*cos(ze)*cos(2*Q)
	+(.0002162 - .0000207*nu2)*cos(2*ze)*cos(2*Q)
	+.0000561*cos(3*ze)*cos(2*Q);
epert = epert
	+.0000343*cos(4*ze)*cos(2*Q)
	+.0000469*sin(3*psi)*cos(2*Q)
	-.0000242*cos(3*psi)*cos(2*Q)
	-.0000205*sin(ze)*sin(3*Q)
	+.0000262*sin(3*ze)*sin(3*Q)
	+.0000208*cos(ze)*cos(3*Q)
	-.0000271*cos(3*ze)*cos(3*Q)
	-.0000382*cos(3*ze)*sin(4*Q)
	-.0000376*sin(3*ze)*cos(4*Q);

w1pert = (0.077108 + 0.007186*nu2 - 0.001533*nu2*nu2)*sin(V)
	+(0.045803 - 0.014766*nu2 - 0.000536*nu2*nu2)*cos(V)
	-0.007075*sin(ze)
	-0.075825*sin(ze)*sin(Q)
	-0.024839*sin(2*ze)*sin(Q)
	-0.008631*sin(3*ze)*sin(Q)
	-0.072586*cos(Q)
	-0.150383*cos(ze)*cos(Q)
	+0.026897*cos(2*ze)*cos(Q)
	+0.010053*cos(3*ze)*cos(Q);
w1pert = w1pert
	-(0.013597 +0.001719*nu2)*sin(ze)*sin(2*Q)
	+(-0.007742 + 0.001517*nu2)*cos(ze)*sin(2*Q)
	+(0.013586 - 0.001375*nu2)*cos(2*ze)*sin(2*Q)
	+(-0.013667 + 0.001239*nu2)*sin(ze)*cos(2*Q)
	+0.011981*sin(2*ze)*cos(2*Q)
	+(0.014861 + 0.001136*nu2)*cos(ze)*cos(2*Q)
	-(0.013064 + 0.001628*nu2)*cos(2*ze)*cos(2*Q);
	
lonpert = l1pert -(w1pert/e);
l = l + l1pert;
M0 = M6 + lonpert;
e = e + epert;
w1 = w1 + w1pert;

apert = .000572*sin(V) -.001590*sin(2*ze)*cos(Q)
	+.002933*cos(V) -.000647*sin(3*ze)*cos(Q)
	+.033629*cos(ze) -.000344*sin(4*ze)*cos(Q)
	-.003081*cos(2*ze) +.002885*cos(ze)*cos(Q)
	-.001423*cos(3*ze) +(.002172 + .000102*nu2)*cos(2*ze)*cos(Q)
	-.000671*cos(4*ze) +.000296*cos(3*ze)*cos(Q)
	-.000320*cos(5*ze) -.000267*sin(2*ze)*sin(2*Q);
apert = apert
	+.001098*sin(Q) -.000778*cos(ze)*sin(2*Q)
	-.002812*sin(ze)*sin(Q) +.000495*cos(2*ze)*sin(2*Q)
	+.000688*sin(2*ze)*sin(Q) +.000250*cos(3*ze)*sin(2*Q);
apert = apert
	-.000393*sin(3*ze)*sin(Q)
	-.000228*sin(4*ze)*sin(Q)
	+.002138*cos(ze)*sin(Q)
	-.000999*cos(2*ze)*sin(Q)
	-.000642*cos(3*ze)*sin(Q)
	-.000325*cos(4*ze)*sin(Q)
	-.000890*cos(Q)
	+.002206*sin(ze)*cos(Q);
apert = apert
	-.000856*sin(ze)*cos(2*Q)
	+.000441*sin(2*ze)*cos(2*Q)
	+.000296*cos(2*ze)*cos(2*Q)
	+.000211*cos(3*ze)*cos(2*Q)
	-.000427*sin(ze)*sin(3*Q)
	+.000398*sin(3*ze)*sin(3*Q)
	+.000344*cos(ze)*cos(3*Q)
	-.000427*cos(3*ze)*cos(3*Q);
	
a = a + apert;
ECC = kepler(e,M0);
nu = truean(e,ECC);
r = a*(1.0 - e * cos(ECC*rad));
u = l + nu - M0 - w2;
ll = longi(w2,i,u);
b = lati(u,i);

b = b
	+0.000747*cos(ze)*sin(Q)
	+0.001069*cos(ze)*cos(Q)
	+0.002108*sin(2*ze)*sin(2*Q)
	+0.001261*cos(2*ze)*sin(2*Q)
	+0.001236*sin(2*ze)*cos(2*Q)
	-0.002075*cos(2*ze)*cos(2*Q);

printf("\nSat  ");
trans(r,b,ll,Stheta,Sr,epli, 120532.);

/* Now Start on Uranus */
	a0 = 244.197470;
	a1 = 429.863546;
	a2 = 0.0003160;
	a3 = -0.00000060;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 19.21814;
	a0 = 0.0463444;
	a1 = -0.00002658;
	a2 = 0.000000077;
	a3 = 0.0;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 0.772464;
	a1 = 0.0006253;
	a2 = 0.0000395;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 98.071581;
	a1 = 0.9857650;
	a2 = -0.0010745;
	a3 = -0.00000061;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 73.477111;
	a1 = 0.4986678;
	a2 = 0.0013117;
	a3 = 0.0;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
	M7 = 72.64878 + 428.37911*T0 + 0.000079*T0*T0;
	M7 = range(M7);
/* now perturbation corrections for Uranus */
	G = 83.76922 + 218.4901*T0;
	S = S/rad;
	P = P/rad;
	Q = Q/rad;
	H = 2.0*G - S;
	ze = S - P;
	eta = S - Q;
	oth = G - S;
	S = S*rad;
	G = range(G)*rad;
	P = P*rad;
	Q = Q*rad;
	H = range(H)*rad;
	ze = range(ze)*rad;
	eta = range(eta)*rad;
	oth = range(oth)*rad;
	
l1pert = (0.864319 - 0.001583*nu2)*sin(H)
	+(0.082222 - 0.006833*nu2)*cos(H)
	+0.036017*sin(2*H)
	-0.003019*cos(2*H)
	+0.008122*sin(W);
	
epert = (-.0003349 + .0000163*nu2)*sin(H)
	+.0020981*cos(H)
	+.0001311*cos(H);
	
w1pert = 0.120303*sin(H)
	+(0.019472 - 0.000947*nu2)*cos(H)
	+0.006197*sin(2*H);
	
lonpert = l1pert -(w1pert/e);
l = l + l1pert;
M0 = M7 + lonpert;
e = e + epert;
w1 = w1 + w1pert;

a = a - 0.003825*cos(H);
ECC = kepler(e,M0);
nu = truean(e,ECC);
r = a*(1.0 - e * cos(ECC*rad));
u = l + nu - M0 - w2;
ll = longi(w2,i,u);
b = lati(u,i);

ll = ll
	+(0.010122 - 0.000988*nu2)*sin(S+eta)
	+(-0.038581 + 0.002031*nu2 - 0.001910*nu2*nu2)*cos(S+eta)
	+(0.034964 - 0.001038*nu2 + 0.000868*nu2*nu2)*cos(2*S+eta)
	+0.005594*sin(S +3*oth);
ll = ll
	-0.014808*sin(ze)
	-0.005794*sin(eta)
	+0.002347*cos(eta)
	+0.009872*sin(oth)
	+0.008803*sin(2*oth)
	-0.004308*sin(3*oth);
	
b = b 
	+(0.000458*sin(eta) - 0.000642*cos(eta) - 0.000517*cos(4*oth))
	*sin(S)
	-(0.000347*sin(eta) + 0.000853*cos(eta) + 0.000517*sin(4*eta))
	*cos(S)
	+0.000403*(cos(2*oth)*sin(2*S) + sin(2*oth)*cos(2*S));
	
r = r
	-.025948
	+.004985*cos(ze)
	-.001230*cos(S)
	+.003354*cos(eta)
	+(.005795*cos(S) - .001165*sin(S) + .001388*cos(2*S))*sin(eta)
	+(.001351*cos(S) + .005702*sin(S) + .001388*sin(2*S))*cos(eta)
	+.000904*cos(2*oth)
	+.000894*(cos(oth) - cos(3*oth));
printf("\nUra  ");
trans(r,b,ll,Stheta,Sr,epli, 51113.);

/* Now start Neptune */
	a0 = 84.457994;
	a1 = 219.885914;
	a2 = 0.0003205;
	a3 = -0.00000060;
	l = poly(a0,a1,a2,a3,T0);
	l = range(l);
	a = 30.10957;
	a0 = 0.00899704;
	a1 = 0.000006330;
	a2 = -0.000000002;
	a3 = 0.0;
	e = poly(a0,a1,a2,a3,T0);
	a0 = 1.779242;
	a1 = -0.0095436;
	a2 = -0.0000091;
	i = poly(a0,a1,a2,a3,T0);
	a0 = 276.045975;
	a1 = 0.3256394;
	a2 = 0.00014095;
	a3 = 0.000004113;
	w1 = poly(a0,a1,a2,a3,T0);
	w1 = range(w1);
	a0 = 130.681389;
	a1 = 1.0989350;
	a2 = 0.00024987;
	a3 = -0.000004718;
	w2 = poly(a0,a1,a2,a3,T0);
	w2 = range(w2);
	M8 = 37.73063 + 218.46134*T0 -0.000070*T0*T0;
	M8 = range(M8);					/* 1.01 fix */
	
/* now perturbation corrections for neptune */
	G = G/rad;
	P = P/rad;
	Q = Q/rad;
	S = S/rad;
	ze = G - P;
	eta = G - Q;
	oth = G - S;
	G = G*rad;
	P = P*rad;
	Q = Q*rad;
	S = S*rad;
	ze = range(ze)*rad;
	eta = range(eta)*rad;
	oth = range(oth)*rad;
	
l1pert = (-0.589833 + 0.001089*nu2)*sin(H)
	+(-0.056094 + 0.004658*nu2)*cos(H)
	-0.024286*sin(2*H);
	
epert = .0004389*sin(H)
	+.0004262*cos(H)
	+.0001129*sin(2*H)
	+.0001089*cos(2*H);
	
w1pert = 0.024039*sin(H)
	-0.025303*cos(H)
	+0.006206*sin(2*H)
	-0.005992*cos(2*H);
	
	
lonpert = l1pert -(w1pert/e);
l = l + l1pert;
M0 = M8 + lonpert;
e = e + epert;
w1 = w1 + w1pert;

a = a - 0.000817*sin(H)
	+0.008189*cos(H)
	+0.000781*cos(2*H);
	
ECC = kepler(e,M0);
nu = truean(e,ECC);
r = a*(1.0 - e * cos(ECC*rad));
u = l + nu - M0 - w2;
ll = longi(w2,i,u);
b = lati(u,i);

ll = ll
	-0.009556*sin(ze)
	-0.005178*sin(eta)
	+0.002572*sin(2*oth)
	-0.002972*cos(2*oth)*sin(G)
	-0.002833*sin(2*oth)*cos(G);
	
b = b 
	+0.000336*cos(2*oth)*sin(G)
	+0.000364*sin(2*oth)*cos(G);
	
r = r
	-.040596
	+.004992*cos(ze)
	+.002744*cos(eta)
	+.002044*cos(oth)
	+.001051*cos(2*oth);
printf("\nNep  ");
trans(r,b,ll,Stheta,Sr,epli, 49531.);

putchar('\n');
exit(0);
} /* end of program main */


initopts(argc,argv)
int argc;
char *argv[];
{
	bool got[256];		/* guard against multiple usages of options */
	char timebuf[20];	/* copy of -t argument */
	int idx;		/* loop index */
	char c;			/* an option character */
	char *c_ptr;
	float temp;


	/* init that no options have been parsed yet */
	for (idx = 0; idx < NUMELEM(got); idx++) {
		got[idx] = false;
	}

	/*
	 * Loop through the options, storing that information.  Make sure none
	 * are used multiple times.
	 */
	while ((c = getopt(argc, argv, "d:t:z:a:o:")) != -1) {
		if (got[c]) {
			error("option -%c is used multiple times", c);
		}
		got[c] = true;

		switch (c) {
		case 'd':
			if (sscanf(optarg, "%ld/%ld/%ld", &mo, &day, &yr) != 3){
				error("invalid format %s for -d option",
						optarg);
			}
			if (mo < 1 || mo > 12) {
				error("invalid month %ld in -d option", mo);
			}
			if (day < 1 || day > 31) {
				error("invalid day %ld in -d option", day);
			}
			if (yr < 1) {
				error("invalid year %ld in -d option", yr);
			}
			if (yr < 1000) {
				printf("WARNING: year %ld in -d option is less than 1000; give all digits", yr);
			}
			break;

		case 't':
			/*
			 * To be able to use hms_str2float, we need to convert
			 * colons to h and m.  To avoid overwriting the command
			 * line, make a copy of this argument.
			 */
			strncpy(timebuf, optarg, sizeof (timebuf));
			timebuf[sizeof (timebuf) - 1] = '\0';
			c_ptr = strchr(timebuf, ':');
			if (c_ptr != NULL) {
				*c_ptr = 'h';
				c_ptr = strchr(timebuf, ':');
				if (c_ptr != NULL) {
					*c_ptr = 'm';
				}
			}
			if (hms_str2float(timebuf, &temp) != 0) {
				error("invalid -t option %s", optarg);
			}

			/* need to set the integer breakdown of the time */
			float_to_3_longs(temp, &th, &tm, &ts);
			break;

		case 'z':
			if (sscanf(optarg, "%d", &tz) != 1) {
				error("invalid -z option %s", optarg);
			}
			tzs = "   ";
			break;

		case 'a':
			if (dms_str2float(optarg, &temp) != 0) {
				error("invalid -a option %s", optarg);
			}
			if (temp < -90.0 || temp > 90.0) {
				error("-a option %s must be between -90 and 90 degrees", optarg);
			}
			float_to_3_longs(temp, &latd, &latm, &lats);
			break;

		case 'o':
			if (dms_str2float(optarg, &temp) != 0) {
				error("invalid -o option %s", optarg);
			}
			if (temp < -180.0 || temp > 180.0) {
				error("-o option %s must be between -180 and 180 degrees", optarg);
			}
			float_to_3_longs(temp, &lond, &lonm, &lons);
			break;

		default:
			usage();
		}
	}
}


/*
 * Function:	hms_str2float
 *
 * Description:	This function converts a string representing hours, minutes,
 *		and seconds to a floating point number in hours.  These
 *		formats are allowed:
 *
 * 			HOURS
 * 			HOURS h
 * 			HOURS h MINUTES
 * 			HOURS h MINUTES m
 * 			HOURS h MINUTES m SECONDS
 * 			HOURS h MINUTES m SECONDS s
 *
 *		where HOURS, MINUTES, and SECONDS are numbers having no sign
 *		and there are not actually any blanks between tokens.  Only the
 *		last number given may contain a decimal point.  Whatever
 *		numbers are given must be in these ranges:
 *
 *			0 <= hours < 24
 *			0 <= minutes < 60
 *			0 <= seconds < 60
 *
 *		The sum must be less than 24.
 *
 * Returns:	0 if success, -1 if failure.
 */

int
hms_str2float(

char *str,		/* the string input */
float *ans_ptr		/* answer filled in, valid only on success */
)
{
	char *beg_ptr;		/* point at first char of a number */
	char *end_ptr;		/* point after last char of a number */
	char *c_ptr;		/* point at a char */
	float temp;		/* each number as parsed */


	/* only these characters are allowed in the string */
	if (str[0] == '\0' || strspn(str, "0123456789.hms") != strlen(str)) {
		 return -1;
	}

	/* if a decimal point anywhere, it must be only in the last number */
	c_ptr = strchr(str, '.');
	if (c_ptr != NULL) {
		c_ptr++;
		c_ptr += strspn(c_ptr, "0123456789");
		if (*c_ptr != '\0' && *(c_ptr + 1) != '\0') {
			return -1;
		}
	}

	beg_ptr = str;		/* start of hours number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != 'h' && *end_ptr != '\0') {
		return -1;	/* can't parse hours or junk after it */
	}
	if (temp >= 24.0) {
		return -1;
	}
	*ans_ptr = temp;
	if (*end_ptr == '\0' || *end_ptr == 'h' && *(end_ptr + 1) == '\0') {
		return 0;	/* nothing, or just "h", after hours */
	}

	beg_ptr = end_ptr + 1;	/* start of minutes number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != 'm' && *end_ptr != '\0') {
		return -1;	/* can't parse minutes or junk after it */
	}
	if (temp >= 60.0) {
		 return -1;
	}
	*ans_ptr += temp / 60.0;
	if (*end_ptr == '\0' || *end_ptr == 'm' && *(end_ptr + 1) == '\0') {
		return 0;	/* nothing, or just "m", after minutes */
	}

	beg_ptr = end_ptr + 1;	/* start of seconds number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != 's' && *end_ptr != '\0') {
		return -1;	/* can't parse seconds or junk after it */
	}
	if (temp >= 60.0) {
		return -1;
	}
	*ans_ptr += temp / 3600.0;
	if (*end_ptr == '\0' || *end_ptr == 's' && *(end_ptr + 1) == '\0') {
		return 0;	/* nothing, or just "s", after seconds */
	}

	return -1;		/* extra junk after the end */
}



/*
 * Function:	dms_str2float
 *
 * Description:	This function converts a string representing degrees, minutes,
 *		and seconds to a floating point number in degrees.  These
 *		formats are allowed:
 *
 * 			DEGREES
 * 			DEGREES o
 * 			DEGREES o ARCMINUTES
 * 			DEGREES o ARCMINUTES '
 * 			DEGREES o ARCMINUTES ' ARCSECONDS
 * 			DEGREES o ARCMINUTES ' ARCSECONDS "
 *
 *		where DEGREES, ARCMINUTES, and ARCSECONDS are numbers,
 *		ARCMINUTES and ARCSECONDS having no sign, and DEGREES
 *		optionally having a + or - sign, and there are not actually any
 *		blanks between tokens.  Only the last number given may contain
 *		a decimal point.  If DEGREES has a sign, it is assumed to apply
 *		to all the numbers.  Whatever numbers are given must be in
 *		these ranges (disregarding the sign):
 *
 *			0 <= degrees < 360
 *			0 <= arcminutes < 60
 *			0 <= arcseconds < 60
 *
 *		The sum must be less than 360.
 *
 * Returns:	0 if success, -1 if failure.
 */

int
dms_str2float(

char *str,		/* the string input */
float *ans_ptr		/* answer filled in, valid only on success */
)
{
	char *beg_ptr;		/* point at first char of a number */
	char *end_ptr;		/* point after last char of a number */
	char *c_ptr;		/* point at a char */
	float temp;		/* each number as parsed */
	int sign;		/* -1 if negative input, else 1 */


	/* set sign if present, and skip by it */
	if (str[0] == '-') {
		sign = -1;
		str++;
	} else if (str[0] == '+') {
		sign = 1;
		str++;
	} else {
		sign = 1;
	}

	/* only these characters are allowed in the rest of the string */
	if (str[0] == '\0' || strspn(str, "0123456789.o'\"") != strlen(str)) {
		 return -1;
	}

	/* if a decimal point anywhere, it must be only in the last number */
	c_ptr = strchr(str, '.');
	if (c_ptr != NULL) {
		c_ptr++;
		c_ptr += strspn(c_ptr, "0123456789");
		if (*c_ptr != '\0' && *(c_ptr + 1) != '\0') {
			return -1;
		}
	}

	beg_ptr = str;		/* start of degrees number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != 'o' && *end_ptr != '\0') {
		return -1;	/* can't parse hours or junk after it */
	}
	if (temp > 360.0) {
		 return -1;
	}
	*ans_ptr = temp;
	if (*end_ptr == '\0' || *end_ptr == 'o' && *(end_ptr + 1) == '\0') {
		*ans_ptr *= sign;
		return 0;	/* nothing, or just "o", after degrees */
	}

	beg_ptr = end_ptr + 1;	/* start of arcminutes number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != '\'' && *end_ptr != '\0') {
		return -1;	/* can't parse arcminutes or junk after it */
	}
	if (temp >= 60.0) {
		return -1;
	}
	*ans_ptr += temp / 60.0;
	if (*end_ptr == '\0' || *end_ptr == '\'' && *(end_ptr + 1) == '\0') {
		*ans_ptr *= sign;
		return 0;	/* nothing, or just "'", after arcminutes */
	}

	beg_ptr = end_ptr + 1;	/* start of arcseconds number */
	errno = 0;
	temp = strtof(beg_ptr, &end_ptr);
	if (errno != 0 || end_ptr == beg_ptr ||
			*end_ptr != '"' && *end_ptr != '\0') {
		return -1;	/* can't parse arcseconds or junk after it */
	}
	if (temp >= 60.0) {
		return -1;
	}
	*ans_ptr += temp / 3600.0;
	if (*end_ptr == '\0' || *end_ptr == '"' && *(end_ptr + 1) == '\0') {
		*ans_ptr *= sign;
		return 0;	/* nothing, or just "\"", after arcseconds */
	}

	return -1;
}

void
float_to_3_longs(float f, long *a_ptr, long *b_ptr, long *c_ptr)
{
	int sign;

	/* remember the sign, and make f positive */
	if (f < 0.0) {
		sign = -1;
		f = -f;
	} else {
		sign = 1;
	}

	/* add half a second so that round off is correct */
	f += 0.5 / 3600.0;

	/* break it out into the 3 longs */
	*a_ptr = (long)f;
	*b_ptr = (long)(60 * (f - *a_ptr));
	*c_ptr = (long)(3600 * (f - *a_ptr - *b_ptr / 60.0));

	/* if it was negative, negate all three */
	if (sign == -1) {
		*a_ptr = -*a_ptr;
		*b_ptr = -*b_ptr;
		*c_ptr = -*c_ptr;
	}
}

usage()
{
printf("Usage: planet [-t H:M:S] [-d m/d/y] [-z tz] [-a DoM'S\"] [-o DoM'S\"]\n\
      where\n\
      t = time (H:M:S [H=hours, M=mins, S=secs] 24-hour clock, default=now)\n\
      d = date (month/day/year, must supply all digits of year, default=today)\n\
      z = timezone number (count west from Greenwich, default=central)\n\
      a = latitude (DoM'S\" [D=degrees, M=mins, S=secs] north, default=42o2')\n\
      o = longitude (DoM'S\" [D=degrees, M=mins, S=secs] west, default=88o16')\n\
In time, latitude, and longitude, the seconds may be omitted, or minutes and\n\
seconds may be omitted.  Also, the symbol after the last number (o'\":) may\n\
be omitted.  Use negative latitude for south, negative longitude for east.\n\
");
exit(1);
}


long cls()
{
	long i;
	for (i=0;i<30;i++)
	{
		putchar('\n');
	}
}

double poly(a0,a1,a2,a3,t)
	double a0,a1,a2,a3,t;
{
	return(a0+a1*t+a2*t*t+a3*t*t*t);
}
double aint(z)
	double z;
{
	long trunk;
	
	trunk = (long)z;
	z = (double) trunk;
	return(z);
}
double kepler(e,M)
	double e,M;
{
	double corr,e0,E0,E1;
	e0 = e /rad;
	corr = 1;
	E0=M;
	while (corr > 0.000001)
	{
		corr = (M + e0* sin(E0*rad) -E0)/(1-e*cos(E0*rad));
		E1 = E0 + corr;
		if (corr < 0)
		{
			corr = -1.0* corr ;
		}
		E0 = E1;
	}
	
	return(E1);
}

double truean(e,E)
	double e,E;
{
	double nu;

	nu = 2.0 * atan(sqrt((1+e)/(1-e))*tan(E*rad/2));
	nu = nu/rad;
	if (nu < 0.0)
	{
		nu = nu + 360.0;
	}
	if (fabs(nu-E) > 90.0)
	{
		if (nu > 180.0)
		{
			nu = nu - 180.0;
		}
		else
		{
			nu = nu + 180.0;
		}
	}
return(nu);
}

double longi(w2,i,u)
	double w2,i,u;
{
	double x,y,l;
	
	y=cos(i*rad)*sin(u*rad);
	x=cos(u*rad);
	l = atan2(y,x);
	l = l/rad;
	if (l < 0.0)
	{
		l = l + 360.0;
	}
	return(l+ w2);
}

double lati(u,i)
	double u,i;
{
	double b;
	b = asin(sin(u*rad)*sin(i*rad))/rad;
	return(b);
}


double range(val)
	double val;
{
	while (val < 0.0)
	{
		val = val + 360.0;
	}
	if (val > 360.0)
	{
		val = val - (aint(val/360.0)*360.0);
	}
	return(val);
}

long trans(r,b,ll,Stheta,Sr,epli, diam)
	double r,b,ll,Stheta,Sr,epli, diam;
{
	double N,D,lambda,delta,beta,RA,DEC;
	
		N = r * cos(b*rad) * sin((ll - Stheta)*rad);
		D = r * cos(b*rad) * cos((ll - Stheta)*rad) + Sr;
		lambda = atan2(N,D)/rad;
		if (lambda < 0.0)
		{
			lambda = lambda + 360.0;
		}
		lambda = range(lambda+Stheta);
		delta = sqrt(N*N + D*D + (r*sin(b*rad))*(r*sin(b*rad)));
		beta = asin(r*sin(b*rad)/delta)/rad;
		N = sin(lambda*rad)*cos(epli*rad)
		    - tan(beta*rad)*sin(epli*rad);
		D = cos(lambda*rad);
		RA = atan2(N,D)/rad;
		DEC = asin(sin(beta*rad)*cos(epli*rad)
		     +cos(beta*rad)*sin(epli*rad)*sin(lambda*rad))/rad;
		speak(false, RA,DEC,delta, diam);
		return(0);
}

long speak(doing_sun, ra,dec,dis,diam)
	bool doing_sun;
	double ra,dec,dis,diam;
{
	double ra_rad, dec_rad;	/* in radians */
	double obj_x, obj_y, obj_z;	/* coords in same units as "dis" is */
	double elong_rad;		/* angle between object and sun */
	double elong_deg;		/* earth_sun in degrees */
	double earth_sun_rad; /* angle between earth and sun, viewed from obj */
	double separation;		/* dist between object and sun */
	int min;
	double illum;		/* fraction of object illuminated earth sees */
	long h, m, s, deg;
	char decsign;		/* sign of declination */
	
	if ( ra < 0)
	{
		ra = ra + 360.0;
	}
	ra_rad = ra / 180 * PI;
	dec_rad = dec / 180 * PI;

	ra /= 15.0;		/* convert from degs to hours */
	ra += .5/3600.;		/* add 1/2 second for rounding */
	if (ra >= 24)		/* because we added the .5/3600 */
		ra -= 24;
	s = ra * 3600;
	h = s / 3600;
	m = (s / 60) % 60;
	s = s - 3600 * h - 60 * m;
	printf("%2ldh %2ldm %2lds", h, m, s);

	if (dec >= 0) {
		decsign = '+';
	} else {
		decsign = '-';
		dec = -dec;
	}
	dec += .5/60.;		/* add 1/2 minute for rounding */
	deg = (long)aint(dec);
	m   =(long)((dec - deg)*60);
	printf("  %c%2ldo %2ld' ", decsign, deg, m);
	printf("%6.3f",dis);

	/* print width in arcseconds, first converting dis from km to AU */
	printf("%7.1f\"", 2.0 *
		asin(diam / 2.0 / (dis * 149598000.)) * (180. / PI) * 3600.);

	if (doing_sun) {
		printf("   0o  0'  ---- ");
	} else {
		/* get coords of the object */
		get_coords(dis, 15.0 * ra, (decsign == '-' ? -dec : dec),
				&obj_x, &obj_y, &obj_z);

		/* use dot product of the vectors to find angle */
		elong_rad = acos((Sun_x * obj_x + Sun_y * obj_y +
				Sun_z * obj_z) / (Sun_d * dis));

		/* print elongation in degrees and arcminutes */
		elong_deg = elong_rad * 180 / PI;
		deg = elong_deg;
		min = (elong_deg - deg) * 60 + 0.5;
		printf(" %3do %2d' ", deg, min);

		/* use law of cosines to find dist between sun and object */
		separation = sqrt(dis * dis + Sun_d * Sun_d -
				2.0 * dis * Sun_d * cos(elong_rad));
		/*
		 * Use law of sines to find angle between earth and sun.  First
		 * we solve for sin(earth_sun_rad) and "asin" that.  But if the
		 * angle is obtuse, we have to flip the asin result so that we
		 * are in the second quadrant.
		 */
		earth_sun_rad = asin(Sun_d * sin(elong_rad) / separation);
		if (Sun_d * Sun_d > dis * dis + separation * separation) {
			earth_sun_rad = PI - earth_sun_rad;
		}

		/* of the side earth sees, what fraction is illuminated */
		illum = (1.0 + cos(earth_sun_rad)) / 2.0;

		printf(" %3d%% ", (int)(100.0 * illum + 0.5));
	}

	praltaz(ra_rad, dec_rad);	/* print altitude and azimuth */

	return(0);
}

void
praltaz(ra, dec)
double ra;		/* right ascension in radians */
double dec;		/* declination in radians */
{
	double hourangle;	/* in radians; later in hours for printing */
	double altitude;	/* in radians; later in degrees for printing */
	double azimuth;		/* in radians; later in degrees for printing */

	double sinalt;		/* sin(altitude) */
	double t;		/* another temp variable */
	char sign;		/* another temp variable */

	int hr, deg, min, sec;	/* used to set up for printing */

	hourangle = greensid - ra - longitude;
	hourangle = pfmod(hourangle, 2 * PI);
	sinalt = cos(dec) * cos(hourangle) * cos(latitude) +
		sin(dec) * sin(latitude);
	altitude = asin(sinalt);
	t = acos(-cos(dec) * sin(hourangle) / sqrt(1 - sinalt * sinalt));
	if (cos(dec) * cos(hourangle) * sin(latitude) <
			sin(dec) * cos(latitude))
		t = -t;
	azimuth = pfmod(t + PI / 2, 2 * PI);

	hourangle *= 12 / PI;		/* convert to hours */
	hourangle += .5 / 3600.;	/* add 1/2 second for rounding */
	if (hourangle >= 24)		/* due to the 1/2 second */
		hourangle -= 24;
	sec = hourangle * 3600;
	hr = sec / 3600;
	min = (sec / 60) % 60;
	sec = sec - 3600 * hr - 60 * min;
	printf(" %2dh %2dm %2ds", hr, min, sec);

	altitude *= 180 / PI;		/* convert to degrees */
	if (altitude >= 0) {
		sign = '+';
	} else {
		altitude = -altitude;
		sign = '-';
	}
	altitude += .5 / 60.;		/* add 1/2 minute for rounding */
	deg = altitude;
	min = (altitude - deg) * 60;
	printf("  %c%2do %2d'", sign, deg, min);

	azimuth *= 180 / PI;		/* convert to degrees */
	azimuth += .5 / 60.;		/* add 1/2 minute for rounding */
	if (azimuth >= 360)		/* due to the 1/2 minute */
		azimuth -= 360;
	deg = azimuth;
	min = (azimuth - deg) * 60;
	printf(" %3do %2d'", deg, min);
}

/*
 *	pfmod()		find a double modulo another double
 *
 *	This function finds the mathematical modulo of one "double"
 *	number with another.  (The "%" operation in C works only for
 *	integers.)  The second number is assumed to be nonzero, and
 *	the answer will be nonnegative (hence the "p").
 *
 *	Parameters:	a	first number
 *			b	second number
 *
 *	Return value:	a % b
 */

double
pfmod(a, b)

double a;
double b;

{
	long whole;			/* integer part of a / b */
	int reverse;			/* reverse answer if a < 0 */
	double answer;

	if (b < 0.)
		b = -b;

	reverse = 0;
	if (a < 0) {
		a = -a;
		reverse = 1;
	}
	whole = a / b;			/* integer part of division */
	answer = a - b * whole; 	/* fractional part of division */
	if (reverse && answer != 0.)
		answer = b - answer;
	return(answer);
}

/*
 *	get_coords()	find X,Y,Z coords of an object
 *
 *	This function is given the distance, right ascension, and declination
 * 	of an object.  It returns the X,Y,Z coordinates, in the same units as
 *	the distance was.
 *
 *	Return value:	void
 */

void
get_coords(dist, ra_deg, dec_deg, obj_x_ptr, obj_y_ptr, obj_z_ptr)

double dist;		/* distance, in any units */
double ra_deg;		/* right ascension in degrees */
double dec_deg;		/* declination in degrees */
double *obj_x_ptr;	/* put X coordinate here */
double *obj_y_ptr;	/* put Y coordinate here */
double *obj_z_ptr;	/* put Z coordinate here */

{
	double ra_rad, dec_rad;		/* R.A. and dec in radians */

	ra_rad = ra_deg / 180 * PI;
	dec_rad = dec_deg / 180 * PI;

	*obj_x_ptr = dist * cos(dec_rad) * cos(ra_rad);
	*obj_y_ptr = dist * cos(dec_rad) * sin(ra_rad);
	*obj_z_ptr = dist * sin(dec_rad);
}

/*
 * Function:	error
 *
 * Description:	Print an error message and exit.  It is called with parameters
 *		like printf.  It adds some additional output and prints to
 *		stderr.
 *
 * Returns:	does not return; exits with 1
 */

void
error(char *format, ...)
{
	va_list arglist;


	fprintf(stderr, "%s: error: ", Prog);

	va_start(arglist, format);
	vfprintf(stderr, format, arglist);
	va_end(arglist);

	fprintf(stderr, ".\n");

	exit(1);
}

